// DS1867KDlg.cpp : implementation file
//

#include "stdafx.h"
#include "DS1867K.h"
#include "DS1867KDlg.h"
#include "DSPIC11.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

CdsPic DS3900;
/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDS1867KDlg dialog

CDS1867KDlg::CDS1867KDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CDS1867KDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDS1867KDlg)
	m_ucEDIT_Pot0 = 0;
	m_ucEDIT_Pot1 = 0;
	m_sEDIT_Status = _T("");
	m_RADIO_Stack = -1;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CDS1867KDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDS1867KDlg)
	DDX_Text(pDX, IDC_EDIT_Pot0, m_ucEDIT_Pot0);
	DDV_MinMaxByte(pDX, m_ucEDIT_Pot0, 0, 255);
	DDX_Text(pDX, IDC_EDIT_Pot1, m_ucEDIT_Pot1);
	DDV_MinMaxByte(pDX, m_ucEDIT_Pot1, 0, 255);
	DDX_Text(pDX, IDC_EDIT_Status, m_sEDIT_Status);
	DDV_MaxChars(pDX, m_sEDIT_Status, 100);
	DDX_Radio(pDX, IDC_RADIO_Pot0, m_RADIO_Stack);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CDS1867KDlg, CDialog)
	//{{AFX_MSG_MAP(CDS1867KDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(ID_Read, OnRead)
	ON_BN_CLICKED(ID_Write, OnWrite)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDS1867KDlg message handlers

BOOL CDS1867KDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	if(DS3900.BoardPresent())
	{
		m_sEDIT_Status= "DS3900 Found!";
		DS3900.Write1(false);  //initialize clock
		DS3900.Write2(false);  //initialize reset
		OnRead();
	}
	else
	{
		m_sEDIT_Status = "DS3900 not found!@#$";
		UpdateData(FALSE);
		MessageBox("DS3900 Not Found\nCheck Power and Serial Cable\nRestart Application","DS3900 Error");
	}
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CDS1867KDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CDS1867KDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CDS1867KDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CDS1867KDlg::OnRead() 
{
	int success;
	bool bit;
	unsigned char mask=0x80;
	unsigned char pot0=0;
	unsigned char pot1=0;
	if(DS3900.BoardPresent())
	{
		success = DS3900.Write2(true);					//pull reset high

		if(success)
		{
			success += DS3900.Read5(bit);				//Read Cout (stack bit first)
			success += DS3900.Write4(bit);				//Copy Read Contents to DQ
			success += DS3900.Write1(true);				//clock bit
			success += DS3900.Write1(false);			//clock bit
			m_RADIO_Stack = bit;
			
			if(success == 5)
			{
				for(int x = 0; x <8 ; x++)
				{
					success += DS3900.Read5(bit);		//Read Cout (stack bit first)
					success += DS3900.Write4(bit);		//Copy Read Contents to DQ
					success += DS3900.Write1(true);		//clock bit
					success += DS3900.Write1(false);	//clock bit
					if(bit)
						pot1 |= mask;
					mask = mask >> 1;
				}
				m_ucEDIT_Pot1 = pot1;
				mask=0x80;
				
				for(int y = 0; y <8 ; y++)
				{
					success += DS3900.Read5(bit);		//Read Cout (stack bit first)
					success += DS3900.Write4(bit);		//Copy Read Contents to DQ
					success += DS3900.Write1(true);		//clock bit
					success += DS3900.Write1(false);	//clock bit
					if(bit)
						pot0 |= mask;
					mask = mask >> 1;
				}
				m_ucEDIT_Pot0 = pot0;				
			}

		}
		success += DS3900.Write2(false);    //pull reset low

		if(success == 70)
			m_sEDIT_Status = "Successful Read";
		else
			m_sEDIT_Status = "Read Failed";
	
	}

	UpdateData(FALSE);
}

void CDS1867KDlg::OnWrite() 
{
	int success;
	UpdateData(TRUE);
	unsigned char mask = 0x80;
	unsigned char pot0 = m_ucEDIT_Pot0;
	unsigned char pot1 = m_ucEDIT_Pot1;
	
	bool bit = false;
	if(m_RADIO_Stack)
		bit = true;

	if(DS3900.BoardPresent())
	{
		success = DS3900.Write2(true);    //pull reset high

		if(success)
		{
			success += DS3900.Write4(bit);	//write stack select bit
			success += DS3900.Write1(true);				//clock bit
			success += DS3900.Write1(false);			//clock bit
			
			if(success == 4)
			{
				for(int x = 0; x <8 ; x++)
				{
					if(pot1 & mask)
						success += DS3900.Write4(true);
					else
						success += DS3900.Write4(false);
					success += DS3900.Write1(true);		//clock bit
					success += DS3900.Write1(false);	//clock bit
					mask = mask >> 1;
				}
				
				mask = 0x80;
				for(int y = 0; y <8 ; y++)
				{
					if(pot0 & mask)
						success += DS3900.Write4(true);
					else
						success += DS3900.Write4(false);
					success += DS3900.Write1(true);		//clock bit
					success += DS3900.Write1(false);	//clock bit
					mask = mask >> 1;
				}
			}
		}
		success += DS3900.Write2(false);    //pull reset low
	}

	if(success == 53)
			m_sEDIT_Status = "Successful Write";
		else
			m_sEDIT_Status = "Write Failed";
	UpdateData(FALSE);
	
}
